=== proxygen/CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

add_subdirectory(external)
add_subdirectory(lib)
add_subdirectory(httpserver)
add_subdirectory(httpclient)
add_subdirectory(fuzzers)
