=== debian/changelog ===
proxygen (2021.01.04.00-0ubuntu1ppa3~bionic) bionic; urgency=medium

  * Package proxygen for ubuntu bionic

 -- Bartek Kryza <bkryza@gmail.com>  Tue, 10 Aug 2021 22:24:41 +0200
