=== debian/control ===
Source: proxygen
Priority: optional
Maintainer: Bartek Kryza <bkryza@gmail.com>
Build-Depends: debhelper (>=9),
    autoconf,
    autoconf-archive,
    automake,
    binutils-dev,
    bison,
    cmake,
    dh-autoreconf,
    flex,
    g++ (>= 5.4.0),
    git,
    gperf,
    libboost-all-dev,
    libdouble-conversion-dev,
    libevent-dev,
    libgflags-dev,
    libgoogle-glog-dev,
    libiberty-dev,
    libjemalloc-dev (>= 5.2.1),
    liblz4-dev,
    liblzma-dev,
    libsnappy-dev,
    libssl-dev (>= 1.1.0),
    libcap-dev,
    libtool,
    make,
    pkg-config,
    unzip,
    libfmt-dev (>= 7.0.1),
    folly-dev (>= 2021.01.04.00),
    fizz-dev (>= 2021.01.04.00),
    wangle-dev (>= 2021.01.04.00),
    wget,
    zlib1g-dev,
    libzstd1-dev,
    libsodium-dev
Standards-Version: 3.9.7
Section: libs
Homepage: https://github.com/facebook/proxygen
Vcs-Git: https://github.com/facebook/proxygen.git

Package: proxygen-dev
Section: libdevel
Architecture: amd64
Depends: ${misc:Depends},
    libdouble-conversion-dev,
    libboost-dev,
    libgflags-dev,
    libjemalloc-dev (>= 5.2.1),
    libssl-dev (>= 1.1.0),
    libgoogle-glog-dev,
    libevent-dev,
    folly-dev (>= 2021.01.04.00),
    fizz-dev (>= 2021.01.04.00),
    wangle-dev (>= 2021.01.04.00)
Description: Facebook's C++ HTTP Libraries
    A collection of C++ HTTP libraries including an easy to use HTTP server.
